<template>
    <div class="row justify-center items-center q-py-md">
        <div class="row items-center col-6 font-18 text-black q-mt-xs">
            <q-btn class="
                q-pr-sm 
                q-pl-lg-md 
                q-pl-md-md 
                q-pl-sm-md 
                q-pl-xs-none" 
                flat 
                no-caps 
                @click="selectCurrentPage(1)">
                <q-icon name="arrow_back" color="black" size="25px" />
            </q-btn>
            <div class="label-title-container helvetica-neue-medium">
                {{ $t('preference.updateService') }}
            </div>
        </div>
        <div class="col-6 q-pr-md-xl font-18 text-black q-mt-xs text-right">
            <q-btn
                no-caps
                text-color="white"
                class="button-save"
                :label="$t('button.save')"
                @click="updateService"
            />
        </div>
    </div>
    <div
        class="
            row
            justify-start
            items-center
            q-px-xs-lg q-px-sm-lg
        "
    >
        <div class="col-md-4 col-12 q-mt-xs items-center q-mr-md">
            <p v-if="props.service.parentId != null" class="font-14 q-mb-md helvetica-neue-medium">
                {{ $t('preference.serviceChild') }}
                <span class="text-ff0000 font-10" v-if="!state.serviceName">
                    {{ $t('form.required') }}
                </span>
            </p>
            <p v-else class="font-14 q-mb-md helvetica-neue-medium">
                {{ $t('preference.serviceName') }}
                <span class="text-ff0000 font-10" v-if="!state.serviceName">
                    {{ $t('form.required') }}
                </span>
            </p>
            <q-input
                outlined
                dense
                v-model="state.serviceName"
                bg-color="blue-2"
            ></q-input>
        </div>
        <div v-if="props.service.parentId != null" class="col-md-4 col-12 items-center q-pt-md-none q-pt-xs-md">
            <p class="font-14 q-mb-md-none q-mb-xs-none helvetica-neue-medium">
                {{ $t('preference.serviceParent') }}
            </p>
            <q-select 
                v-model="state.parentName"
                :options="state.parentService"
                option-value="id"
                option-label="name"
            ></q-select>
        </div>
    </div>
</template>
<script lang="ts">
import { defineComponent, reactive, computed, onMounted } from 'vue'
import { useStore } from 'src/store';

export default defineComponent({
    name: 'UpdateService',
    props: {
        service: {
            type: Object,
            required: true
        }
    },
    setup(props, { emit }) {
        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });

        let state = reactive({
            serviceName: '' as any,
            parentName: '' as any,
            parentService: [] as any,
        });
        const serviceList = computed(() => {
            return store.state.service.serviceType;
        });
        const store = useStore();
        const selectCurrentPage = (page: any) => {
            emit('update-servicePage', page);
        };

        const getParentService = () => {
            if (serviceList.value) {
                serviceList.value.forEach((element: any) => {
                    if (!element.parentId) {
                        let parentList = {
                            id: element.id,
                            name: element.name,
                            parentId: element.parentId
                        };
                        state.parentService.push(parentList);
                    }
                })
            }
        }
        
        const loadService = () => {
            if (props.service.parentId != null) {
                state.serviceName = props.service.name
            } else {
                state.serviceName = props.service.name
            }
            serviceList.value.forEach((element: any) => {
                state.parentService.forEach((element2: any) => {
                    if (element.parentId == element2.id) {
                        if (props.service.parentId == element2.id) {
                            state.parentName = element2.name
                        }
                    }
                });
            })
        }

        const updateService = async () => {
            const res = await store.dispatch('service/update', {
                serviceTypeId: props.service.id,
                name: state.serviceName,
                parentId: state.parentName.id
            });
            if (res.status == 200) {
                setTimeout(() => {
                    store.dispatch('service/getServiceTypeList', { 
                        businessId: selectedBusinessId.value 
                    });
                }, 500);
                selectCurrentPage(1);
            }
        }

        onMounted(getParentService);
        onMounted(loadService);
        return {
            state,
            props,
            selectCurrentPage,
            loadService,
            updateService
        }
    },
})
</script>
